HDU2795(Billboard)

Billboard

Problem Description

At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.
On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.
Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.
When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.
If there is no valid location for a new announcement, it is not put on the billboard (that’s why some programming contests have no participants from this university).
Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

Input

There are multiple cases (no more than 40 cases).
The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.
Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

Output

For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can’t be put on the billboard, output “-1” for this announcement.

Sample Input

3 5 5
2
4
3
3
3

Sample Output

1
2
1
3
-1

思路

线段树最大值 + 单点更新。首先想好怎么建线段树,h给的范围比较大,而反观看似不起眼的n比较小。所以可以联想到线段树的区间一定是在h 和 n中取一个最小值建树。广告是按顺序贴的啊,而且每一行的长度都是一样的,如果空白的第一行长度不够这个广告那么所有的行都不够啊。

  1. 由于最开始每个区间的长度都是一样的,所以可以利用线段树的每个叶节点区间保存长度,维护区间最大值。

  2. 查询的时候去查哪个叶节点的区间长度满足当前广告的宽度即可。顺手返回行编号即可。

最开始的时候找满足的区间用二分 + 线段树query,一想复杂度无非也就是O(nlognlogn)但是TLE了。后来想想线段树更新的时候恰好也是一个二分的过程所以两个压缩到一起做就过了。 还是挺好的一个题,巧妙的转化一下。

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;
#define lson k<<1,l,m
#define rson k<<1|1,m+1,r
const int maxn = 2e5+5;
const int inf = 0x3f3f3f3f;
int s[maxn<<2];
inline void build(int k,int l,int r,int w)
{
    if(l == r){
        s[k] = w;
        return ;
    }
    int m = (l + r) >> 1;
    build(lson,w);
    build(rson,w);
    s[k] = max(s[k<<1],s[k<<1|1]); 
}
int update(int k,int l,int r,int ans)
{
    if(l == r){
        if(s[k] >= ans){
            s[k] -= ans;
            return l;		//返回行编号
        }
        else{
            return -1;		//没找到
        }
    }
    int flag = -1;
    int m = (l + r) >> 1;
    if(s[k<<1] >= ans){            //去左边更新 
        flag = update(lson,ans);    
    }
    else if(s[k<<1|1] >= ans){        //去右边更新 
        flag = update(rson,ans);
    }
    s[k] = max(s[k<<1],s[k<<1|1]);     //向上更新 
    return flag;    
}
int main()
{
    int h,w,n,x;
    while(~scanf("%d%d%d",&h,&w,&n)){
        int k = min(h,n);
        build(1,1,k,w);
        for(int i = 0;i < n;i++){
            scanf("%d",&x);
            int ans = update(1,1,k,x);
            printf("%d\n",ans);
        }
    }
    return 0;
}

愿你走出半生,归来仍是少年~

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值